#include "WNDCanvas2.h"
WNDCanvas* pwnd=0;

WNDCanvas::WNDCanvas(){
	CtrlLayout(*this,"WNDCanvasFrames");
	Sizeable(true);
}

GUI_APP_MAIN{
	WNDCanvas w;
	pwnd=&w;pwnd->Run();
	pwnd=NULL;
}

SCtrl& AddSplitter(int where,Ctrl *pfrom){
	//SSplitterFrame& spl=splitters.Create<SSplitterFrame>();
	//spl.FrameAdd(InsetFrame());
	SCtrl& sc=ctrls.Create<SCtrl>();
	sc.spl.Set(sc.SizePos(),100,where);
	if(!pfrom)pfrom=pwnd; sc.frmid=pfrom->GetFrameCount();
	pfrom->AddFrame(sc.spl);
	return sc;
}

void NewPanel(int where,Ctrl *pfrom){
	SCtrl&ctrl=AddSplitter(where,pfrom);
	//ctrl.ctrl.Create<Button>();
	//Button&b=*(Button*)ctrl.ctrl.Get();b.SetLabel("Marana");b.LeftPos(20,100);b.TopPos(20,40);
	////ctrl.ctrl->Add(b);
}

int mfind(Ctrl*p);
void walkthis(Ctrl* ctrl);
void walkchilds(SCtrl* ctrl);
void OnRightUp(Ctrl *pfrom){
	MenuBar::Execute([=](Bar& bar){
		bar.Add("NewLeft", [=] {NewPanel(SplitterFrame::LEFT,pfrom); });
		bar.Add("NewTop", [=] {NewPanel(SplitterFrame::TOP,pfrom); });
		bar.Add("NewRight", [=] {NewPanel(SplitterFrame::RIGHT,pfrom); });
		bar.Add("NewBottom", [=] {NewPanel(SplitterFrame::BOTTOM,pfrom); });
		bar.Separator();
		bar.Add("Remove", [=] {walkthis(pfrom);});
		}
  );
}

int mfind(Ctrl*p){
	for(int a=0;a<ctrls.GetCount();a++){
		if(&ctrls[a]==p)return a;
	}
	return -1;
}
void walkthis(Ctrl* pfrom){
	if(!pfrom)return;
	int a=mfind(pfrom); if(a==-1){PromptOK("\1NotFound");return;}
	SCtrl*sc=&ctrls[a];
	Ctrl*par=sc->GetParent()->GetParent();
	int fid=ctrls[a].frmid;
	walkchilds(sc);
	sc->Remove();/*sc->spl.FrameRemove();*/par->RemoveFrame(sc->spl);
	//if(!ctrls[a].GetChildCount())par->RemoveFrame(fid);
	a=mfind(pfrom);ctrls.Remove(a);//ctrls[a].Remove();
	//par->RemoveFrame(fid);//ctrls.Remove(a);
	//par->RemoveFrame(fid);
	//par->Remove();ctrls.Remove(a);
	//par->GetParent()->Remove();ctrls.Remove(a);
}
void walkchilds(SCtrl* ctrl){
	int a,b;Ctrl *p;
	Ctrl *pc=ctrl->GetFirstChild();
	while(pc){
		p=pc->GetNext(); a=mfind(pc);
		if(a==-1){pc=p;continue;}
		b=pc->GetFirstChild()?mfind(pc->GetFirstChild()):-1;
		if(b==-1){
			Ctrl *ch=pc->GetFirstChild()?pc->GetFirstChild()->GetFirstChild():NULL;
			b=ch?mfind(ch):-1;
		}
		if(b!=-1)walkchilds(&ctrls[b]);
		if(a!=-1){ctrls[a].Remove();ctrls.Remove(a);}
		pc=p;
	}
}



#if 0
WNDCanvas* pwnd=0;

WNDCanvas::WNDCanvas(){
	CtrlLayout(*this,"WNDCanvasFrames");
	Sizeable(true);
}

GUI_APP_MAIN{
	WNDCanvas w;
	pwnd=&w;pwnd->Run();
	pwnd=NULL;
}

SCtrl& AddSplitter(int where,Ctrl *pfrom){
	SSplitterFrame& spl=splitters.Create<SSplitterFrame>();
	//spl.FrameAdd(InsetFrame());
	//ctrls.Create<SCtrl>();
	//Button&b=ctrls.Create<Button>();b.SetLabel("Marana");b.LeftPos(20,100);b.TopPos(20,40);
	ctrls.Create<Button>();
	spl.Set(ctrls.Top().SizePos(),100,where);
	if(!pfrom)pfrom=pwnd; ctrls.Top().pfrm=&spl; ctrls.Top().frmid=pfrom->GetFrameCount();
	pfrom->AddFrame(spl);
	return ctrls.Top();
}

void NewPanel(int where,Ctrl *pfrom){
	SCtrl&ctrl=AddSplitter(where,pfrom);
	//ctrl.Create<Button>();
	//Button&b=*(Button*)ctrl.ctrl.Get();b.SetLabel("Marana");b.LeftPos(20,100);b.TopPos(20,40);
	////ctrl.ctrl->Add(b);
}

int mfind(Ctrl*p);
void OnRightUp(Ctrl *pfrom){
	MenuBar::Execute([=](Bar& bar){
		bar.Add("NewLeft", [=] {NewPanel(SplitterFrame::LEFT,pfrom); });
		bar.Add("NewTop", [=] {NewPanel(SplitterFrame::TOP,pfrom); });
		bar.Add("NewRight", [=] {NewPanel(SplitterFrame::RIGHT,pfrom); });
		bar.Add("NewBottom", [=] {NewPanel(SplitterFrame::BOTTOM,pfrom); });
		bar.Separator();
		bar.Add("Remove", [=] {
			if(!pfrom)return;
			int a=mfind(pfrom); if(a==-1){PromptOK("\1NotFound");return;}
			SCtrl*sc=&ctrls[a];
			Ctrl*par=sc->GetParent();
			//par->RemoveFrame(*sc->pfrm);
			//par->RemoveFrame(sc->frmid);
			ctrls.Remove(a);
			});
		}
  );
}

int mfind(Ctrl*p){
	for(int a=0;a<ctrls.GetCount();a++){
		if(&ctrls[a]==p)return a;
	}
	return -1;
}
#endif
